Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpheaders.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpheaders.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/httpheaders.h	(revision 389)
@@ -0,0 +1,158 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+/** @file httpheaders.h    
+*	@brief This is a utility module that handles HTTP message-headers.
+*
+*	@details An application would use ::HTTPHeaders_Alloc to create a new set of HTTP headers.
+*			 After getting the handle, the application would build in several headers by
+*			 consecutive calls to ::HTTPHeaders_AddHeaderNameValuePair. When the headers are
+*			 constructed, the application can retrieve the stored data by calling one of the
+*			 following functions:
+*				- ::HTTPHeaders_FindHeaderValue - when the name of the header is known and it  
+*				  wants to know the value of that header  
+*				- ::HTTPHeaders_GetHeaderCount - when the application needs to know the count  
+*				  of all the headers  
+*				- ::HTTPHeaders_GetHeader - when the application needs to retrieve the
+*				  <code>name + ": " + value</code> string based on an index.
+*/
+
+#ifndef HTTPHEADERS_H
+#define HTTPHEADERS_H
+
+#include "azure_c_shared_utility/macro_utils.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+#include <cstddef>
+extern "C" {
+#else
+#include <stddef.h>
+#endif
+
+/*Codes_SRS_HTTP_HEADERS_99_001:[ HttpHeaders shall have the following interface]*/
+
+#define HTTP_HEADERS_RESULT_VALUES \
+HTTP_HEADERS_OK,                  \
+HTTP_HEADERS_INVALID_ARG,         \
+HTTP_HEADERS_ALLOC_FAILED,        \
+HTTP_HEADERS_INSUFFICIENT_BUFFER, \
+HTTP_HEADERS_ERROR                \
+
+/** @brief Enumeration specifying the status of calls to various APIs in this module.
+*/
+MU_DEFINE_ENUM(HTTP_HEADERS_RESULT, HTTP_HEADERS_RESULT_VALUES);
+typedef struct HTTP_HEADERS_HANDLE_DATA_TAG* HTTP_HEADERS_HANDLE;
+
+/**
+ * @brief	Produces a @c HTTP_HANDLE that can later be used in subsequent calls to the module.
+ * 			
+ *			This function returns @c NULL in case an error occurs. After successful execution
+ *			::HTTPHeaders_GetHeaderCount will report @c 0 existing headers.
+ *
+ * @return	A HTTP_HEADERS_HANDLE representing the newly created collection of HTTP headers.
+ */
+MOCKABLE_FUNCTION(, HTTP_HEADERS_HANDLE, HTTPHeaders_Alloc);
+
+/**
+ * @brief	De-allocates the data structures allocated by previous API calls to the same handle.
+ *
+ * @param	httpHeadersHandle	A valid @c HTTP_HEADERS_HANDLE value.
+ */
+MOCKABLE_FUNCTION(, void, HTTPHeaders_Free, HTTP_HEADERS_HANDLE, httpHeadersHandle);
+
+/**
+ * @brief	Adds a header record from the @p name and @p value parameters.
+ *
+ * @param	httpHeadersHandle	A valid @c HTTP_HEADERS_HANDLE value.
+ * @param	name			 	The name of the HTTP header to add. It is invalid for
+ * 								the name to include the ':' character or character codes
+ * 								outside the range 33-126.
+ * @param	value			 	The value to be assigned to the header.
+ *
+ *			The function stores the @c name:value pair in such a way that when later
+ *			retrieved by a call to ::HTTPHeaders_GetHeader it will return a string
+ *			that is @c strcmp equal to @c name+": "+value. If the name already exists
+ *			in the collection of headers, the function concatenates the new value
+ *			after the existing value, separated by a comma and a space as in:
+ *			<code>old-value+", "+new-value</code>.
+ * 
+ * @return	Returns @c HTTP_HEADERS_OK when execution is successful or an error code from
+ * 			the ::HTTPAPIEX_RESULT enum.
+ */
+MOCKABLE_FUNCTION(, HTTP_HEADERS_RESULT, HTTPHeaders_AddHeaderNameValuePair, HTTP_HEADERS_HANDLE, httpHeadersHandle, const char*, name, const char*, value);
+
+/**
+ * @brief	This API performs exactly the same as ::HTTPHeaders_AddHeaderNameValuePair
+ * 			except that if the header name already exists then the already existing value
+ * 			will be replaced as opposed to being concatenated to.
+ *
+ * @param	httpHeadersHandle	A valid @c HTTP_HEADERS_HANDLE value.
+ * @param	name			 	The name of the HTTP header to add/replace. It is invalid for
+ * 								the name to include the ':' character or character codes
+ * 								outside the range 33-126.
+ * @param	value			 	The value to be assigned to the header.
+ *
+ * @return	Returns @c HTTP_HEADERS_OK when execution is successful or an error code from
+ * 			the ::HTTPAPIEX_RESULT enum.
+ */
+MOCKABLE_FUNCTION(, HTTP_HEADERS_RESULT, HTTPHeaders_ReplaceHeaderNameValuePair, HTTP_HEADERS_HANDLE, httpHeadersHandle, const char*, name, const char*, value);
+
+/**
+ * @brief	Retrieves the value for a previously stored name.
+ *
+ * @param	httpHeadersHandle	A valid @c HTTP_HEADERS_HANDLE value.
+ * @param	name			 	The name of the HTTP header to find.
+ *
+ * @return	The return value points to a string that shall be @c strcmp equal
+ * 			to the original stored string.
+ */
+MOCKABLE_FUNCTION(, const char*, HTTPHeaders_FindHeaderValue, HTTP_HEADERS_HANDLE, httpHeadersHandle, const char*, name);
+
+/**
+ * @brief	This API retrieves the number of stored headers.
+ *
+ * @param	httpHeadersHandle	A valid @c HTTP_HEADERS_HANDLE value.
+ * @param	headersCount		If non-null, the API writes the number of
+ * 								into the memory pointed at by this parameter.
+ *
+ * @return	Returns @c HTTP_HEADERS_OK when execution is successful or
+ * 			@c HTTP_HEADERS_ERROR when an error occurs.
+ */
+MOCKABLE_FUNCTION(, HTTP_HEADERS_RESULT, HTTPHeaders_GetHeaderCount, HTTP_HEADERS_HANDLE, httpHeadersHandle, size_t*, headersCount);
+
+/**
+ * @brief	This API retrieves the string name+": "+value for the header
+ * 			element at the given @p index.
+ *
+ * @param	handle			A valid @c HTTP_HEADERS_HANDLE value.
+ * @param	index			Zero-based index of the item in the
+ * 							headers collection.
+ * @param   destination		If non-null, the header value is written into a
+ * 							new string a pointer to which is written into this
+ * 							parameters. It is the caller's responsibility to free
+ * 							this memory.
+ *
+ * @return	Returns @c HTTP_HEADERS_OK when execution is successful or
+ * 			@c HTTP_HEADERS_ERROR when an error occurs.
+ */
+MOCKABLE_FUNCTION(, HTTP_HEADERS_RESULT, HTTPHeaders_GetHeader, HTTP_HEADERS_HANDLE, handle, size_t, index, char**, destination);
+
+/**
+ * @brief	This API produces a clone of the @p handle parameter.
+ *
+ * @param   handle  A valid @c HTTP_HEADERS_HANDLE value.
+ *
+ *			If @p handle is not @c NULL this function clones the content
+ *			of the handle to a new handle and returns it.
+ *			
+ * @return	A @c HTTP_HEADERS_HANDLE containing a cloned copy of the
+ * 			contents of @p handle.
+ */
+MOCKABLE_FUNCTION(, HTTP_HEADERS_HANDLE, HTTPHeaders_Clone, HTTP_HEADERS_HANDLE, handle);
+
+#ifdef __cplusplus
+}
+#endif 
+
+#endif /* HTTPHEADERS_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/lock.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/lock.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/lock.h	(revision 389)
@@ -0,0 +1,77 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+/** @file lock.h  
+*	@brief		A minimalistic platform agnostic lock abstraction for thread
+*				synchronization.
+*	@details	The Lock component is implemented in order to achieve thread
+*				synchronization, as we may have a requirement to consume locks
+*				across different platforms. This component exposes some generic
+*				APIs so that it can be extended for platform specific
+*				implementations.
+*/
+
+#ifndef LOCK_H
+#define LOCK_H
+
+#include "azure_c_shared_utility/macro_utils.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef void* LOCK_HANDLE;
+
+#define LOCK_RESULT_VALUES \
+    LOCK_OK, \
+    LOCK_ERROR \
+
+/** @brief Enumeration specifying the lock status.
+*/
+MU_DEFINE_ENUM(LOCK_RESULT, LOCK_RESULT_VALUES);
+
+/**
+ * @brief	This API creates and returns a valid lock handle.
+ *
+ * @return	A valid @c LOCK_HANDLE when successful or @c NULL otherwise.
+ */
+MOCKABLE_FUNCTION(, LOCK_HANDLE, Lock_Init);
+
+/**
+ * @brief	Acquires a lock on the given lock handle. Uses platform
+ * 			specific mutex primitives in its implementation.
+ *
+ * @param	handle	A valid handle to the lock.
+ *
+ * @return	Returns @c LOCK_OK when a lock has been acquired and
+ * 			@c LOCK_ERROR when an error occurs.
+ */
+MOCKABLE_FUNCTION(, LOCK_RESULT, Lock, LOCK_HANDLE, handle);
+
+/**
+ * @brief	Releases the lock on the given lock handle. Uses platform
+ * 			specific mutex primitives in its implementation.
+ *
+ * @param	handle	A valid handle to the lock.
+ *
+ * @return	Returns @c LOCK_OK when the lock has been released and
+ * 			@c LOCK_ERROR when an error occurs.
+ */
+MOCKABLE_FUNCTION(, LOCK_RESULT, Unlock, LOCK_HANDLE, handle);
+
+/**
+ * @brief	The lock instance is destroyed.
+ *
+ * @param	handle	A valid handle to the lock.
+ *
+ * @return	Returns @c LOCK_OK when the lock object has been
+ * 			destroyed and @c LOCK_ERROR when an error occurs.
+ */
+MOCKABLE_FUNCTION(, LOCK_RESULT, Lock_Deinit, LOCK_HANDLE, handle);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* LOCK_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/map.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/map.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/map.h	(revision 389)
@@ -0,0 +1,202 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+/** @file       map.h
+*	@brief		Map is a module that implements a dictionary of @c STRING_HANDLE
+*               keys to @c STRING_HANDLE values.
+*/
+
+#ifndef MAP_H
+#define MAP_H
+
+#include "azure_c_shared_utility/macro_utils.h"
+#include "azure_c_shared_utility/strings.h"
+#include "azure_c_shared_utility/crt_abstractions.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+#include <cstddef>
+extern "C"
+{
+#else
+#include <stddef.h>
+#endif
+
+#define MAP_RESULT_VALUES \
+    MAP_OK, \
+    MAP_ERROR, \
+    MAP_INVALIDARG, \
+    MAP_KEYEXISTS, \
+    MAP_KEYNOTFOUND, \
+    MAP_FILTER_REJECT
+
+/** @brief Enumeration specifying the status of calls to various APIs in this  
+ *  module.
+ */
+MU_DEFINE_ENUM(MAP_RESULT, MAP_RESULT_VALUES);
+
+typedef struct MAP_HANDLE_DATA_TAG* MAP_HANDLE;
+
+typedef int (*MAP_FILTER_CALLBACK)(const char* mapProperty, const char* mapValue);
+
+/**
+ * @brief   Creates a new, empty map.
+ *
+ * @param   mapFilterFunc   A callback function supplied by the caller that is
+ *                          invoked during calls to ::Map_Add and
+ *                          ::Map_AddOrUpdate to provide the caller an
+ *                          opportunity to indicate whether the new entry or
+ *                          the update to an existing entry can be made or not.
+ *                          The callback function can request that the operation
+ *                          be canceled by returning a non-zero value from the
+ *                          callback.
+ *
+ * @return  A valid @c MAP_HANDLE or @c NULL in case an error occurs.
+ */
+MOCKABLE_FUNCTION(, MAP_HANDLE, Map_Create, MAP_FILTER_CALLBACK, mapFilterFunc);
+
+/**
+ * @brief   Release all resources associated with the map.
+ *
+ * @param   handle  The handle to an existing map.
+ */
+MOCKABLE_FUNCTION(, void, Map_Destroy, MAP_HANDLE, handle);
+
+/**
+ * @brief   Creates a copy of the map indicated by @p handle and returns a
+ *          handle to it.
+ *
+ * @param   handle  The handle to an existing map.
+ *
+ * @return  A valid @c MAP_HANDLE to the cloned copy of the map or @c NULL
+ *          in case an error occurs.
+ */
+MOCKABLE_FUNCTION(, MAP_HANDLE, Map_Clone, MAP_HANDLE, handle);
+
+/**
+ * @brief   Adds a key/value pair to the map.
+ *
+ * @param   handle  The handle to an existing map.
+ * @param   key     The @c key to be used for this map entry.
+ * @param   value   The @c value to be associated with @p key.
+ *
+ *          If a non-NULL pointer to a callback function was supplied
+ *          via the @c mapFilterFunc parameter when ::Map_Create was
+ *          called then that callback is invoked when a new entry is
+ *          added and if the callback returns a non-zero value then
+ *          the function cancels the add operation and returns
+ *          @c MAP_FILTER_REJECT.
+ * 
+ * @return  If any of the input parameters are @c NULL then this function
+ *          returns @c MAP_INVALID_ARG. If the key already exists in the
+ *          map then @c MAP_KEYEXISTS is returned. If the filter function
+ *          associated with the map rejects the entry then
+ *          @c MAP_FILTER_REJECT is returned. In case an error occurs when
+ *          the new key is added to the map the function returns @c MAP_ERROR.
+ *          If everything goes well then @c MAP_OK is returned.
+ */
+MOCKABLE_FUNCTION(, MAP_RESULT, Map_Add, MAP_HANDLE, handle, const char*, key, const char*, value);
+
+/**
+ * @brief   Adds/updates a key/value pair to the map.
+ *
+ * @param   handle  The handle to an existing map.
+ * @param   key     The @c key to be used for this map entry.
+ * @param   value   The @c value to be associated with @p key.
+ *
+ *          This function behaves exactly like ::Map_Add except that if the key
+ *          already exists in the map then it overwrites the value with the
+ *          supplied value instead of returning an error. If a non-NULL pointer
+ *          to a callback function was supplied via the @c mapFilterFunc parameter
+ *          when ::Map_Create was called then that callback is invoked when a new
+ *          entry is added or when an existing entry is updated and if the
+ *          callback returns a non-zero value then the function cancels the
+ *          add/update operation and returns @c MAP_FILTER_REJECT.
+ * 
+ * @return  If any of the input parameters are @c NULL then this function
+ *          returns @c MAP_INVALID_ARG. If the filter function associated
+ *          with the map rejects the entry then @c MAP_FILTER_REJECT is
+ *          returned. In case an error occurs when the new key is
+ *          added/updated in the map the function returns @c MAP_ERROR. If
+ *          everything goes well then @c MAP_OK is returned.
+ */
+MOCKABLE_FUNCTION(, MAP_RESULT, Map_AddOrUpdate, MAP_HANDLE, handle, const char*, key, const char*, value);
+
+/**
+ * @brief   Removes a key and its associated value from the map.
+ *
+ * @param   handle  The handle to an existing map.
+ * @param   key     The @c key of the item to be deleted.
+ *
+ * @return  Returns @c MAP_OK if the key was deleted successfully or an
+ *          error code otherwise.
+ */
+MOCKABLE_FUNCTION(, MAP_RESULT, Map_Delete, MAP_HANDLE, handle, const char*, key);
+
+/**
+ * @brief   This function returns a boolean value in @p keyExists if the map
+ *          contains a key with the same value the parameter @p key.
+ *
+ * @param   handle      The handle to an existing map.
+ * @param   key         The key that the caller wants checked.
+ * @param   keyExists   The function writes @c true at the address pointed at
+ *                      by this parameter if the key exists in the map and
+ *                      @c false otherwise.
+ *
+ * @return  Returns @c MAP_OK if the check was performed successfully or an
+ *          error code otherwise.
+ */
+MOCKABLE_FUNCTION(, MAP_RESULT, Map_ContainsKey, MAP_HANDLE, handle, const char*, key, bool*, keyExists);
+
+/**
+ * @brief   This function returns @c true in @p valueExists if at
+ *          least one <key,value> pair exists in the map where the entry's
+ *          value is equal to the parameter @c value.
+ *
+ * @param   handle          The handle to an existing map.
+ * @param   value           The value that the caller wants checked.
+ * @param   valueExists     The function writes @c true at the address pointed at
+ *                          by this parameter if the value exists in the map and
+ *                          @c false otherwise.
+ *
+ * @return  Returns @c MAP_OK if the check was performed successfully or an
+ *          error code otherwise.
+ */
+MOCKABLE_FUNCTION(, MAP_RESULT, Map_ContainsValue, MAP_HANDLE, handle, const char*, value, bool*, valueExists);
+
+/**
+ * @brief   Retrieves the value of a stored key.
+ *
+ * @param   handle  The handle to an existing map.
+ * @param   key     The key to be looked up in the map.
+ *
+ * @return  Returns @c NULL in case the input arguments are @c NULL or if the
+ *          requested key is not found in the map. Returns a pointer to the
+ *          key's value otherwise.
+ */
+MOCKABLE_FUNCTION(, const char*, Map_GetValueFromKey, MAP_HANDLE, handle, const char*, key);
+
+/**
+ * @brief   Retrieves the complete list of keys and values from the map
+ *          in @p values and @p keys. Also writes the size of the list
+ *          in @p count.
+ *
+ * @param   handle      The handle to an existing map.
+ * @param   keys        The location where the list of keys is to be written.
+ * @param   values      The location where the list of values is to be written.
+ * @param   count       The number of stored keys and values is written at the
+ *                      location indicated by this pointer.
+ *
+ * @return  Returns @c MAP_OK if the keys and values are retrieved and written
+ *          successfully or an error code otherwise.
+ */
+MOCKABLE_FUNCTION(, MAP_RESULT, Map_GetInternals, MAP_HANDLE, handle, const char*const**, keys, const char*const**, values, size_t*, count);
+
+/*this API creates a JSON object from the content of the map*/
+MOCKABLE_FUNCTION(, STRING_HANDLE, Map_ToJSON, MAP_HANDLE, handle);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* MAP_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/optimize_size.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/optimize_size.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/optimize_size.h	(revision 389)
@@ -0,0 +1,24 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef OPTIMIZE_SIZE_H
+#define OPTIMIZE_SIZE_H
+
+#if (defined __MSP430FR5969__)
+    #define OPTIMIZE_RETURN_CODES
+    #define NO_VERBOSE_OUTPUT
+    #ifdef DEBUG
+        #define MINIMAL_LOGERROR
+    #else
+        #define NO_LOGGING
+    #endif
+#endif
+
+#if (defined OPTIMIZE_RETURN_CODES)
+    #define MU_FAILURE 1
+#else
+    #define MU_FAILURE __LINE__
+#endif
+
+#endif // OPTIMIZE_SIZE_H
+
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/optionhandler.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/optionhandler.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/optionhandler.h	(revision 389)
@@ -0,0 +1,48 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef OPTIONHANDLER_H
+#define OPTIONHANDLER_H
+
+#include "azure_c_shared_utility/macro_utils.h"
+
+#define OPTIONHANDLER_RESULT_VALUES \
+OPTIONHANDLER_OK, \
+OPTIONHANDLER_ERROR, \
+OPTIONHANDLER_INVALIDARG
+
+MU_DEFINE_ENUM(OPTIONHANDLER_RESULT, OPTIONHANDLER_RESULT_VALUES)
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+typedef struct OPTIONHANDLER_HANDLE_DATA_TAG* OPTIONHANDLER_HANDLE;
+
+/*the following function pointer points to a function that produces a clone of the option specified by name and value (that is, a clone of void* value)*/
+/*returns NULL if it failed to produce a clone, otherwise returns a non-NULL value*/
+/*to be implemented by every module*/
+typedef void* (*pfCloneOption)(const char* name, const void* value);
+
+/*the following function pointer points to a function that frees resources allocated for an option*/
+/*to be implemented by every module*/
+typedef void (*pfDestroyOption)(const char* name, const void* value);
+
+/*the following function pointer points to a function that sets an option for a module*/
+/*to be implemented by every module*/
+/*returns 0 if _SetOption succeeded, any other value is error, if the option is not intended for that module, returns 0*/
+typedef int (*pfSetOption)(void* handle, const char* name, const void* value);
+
+MOCKABLE_FUNCTION(, OPTIONHANDLER_HANDLE, OptionHandler_Create, pfCloneOption, cloneOption, pfDestroyOption, destroyOption, pfSetOption, setOption);
+MOCKABLE_FUNCTION(, OPTIONHANDLER_HANDLE, OptionHandler_Clone, OPTIONHANDLER_HANDLE, handler);
+MOCKABLE_FUNCTION(, OPTIONHANDLER_RESULT, OptionHandler_AddOption, OPTIONHANDLER_HANDLE, handle, const char*, name, const void*, value);
+MOCKABLE_FUNCTION(, OPTIONHANDLER_RESULT, OptionHandler_FeedOptions, OPTIONHANDLER_HANDLE, handle, void*, destinationHandle);
+MOCKABLE_FUNCTION(, void, OptionHandler_Destroy, OPTIONHANDLER_HANDLE, handle);
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /*OPTIONHANDLER*/
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/platform.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/platform.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/platform.h	(revision 389)
@@ -0,0 +1,32 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef PLATFORM_H
+#define PLATFORM_H
+
+#include "azure_c_shared_utility/strings.h"
+#include "azure_c_shared_utility/xio.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#define GUID_LENGTH 64
+
+typedef enum PLATFORM_INFO_OPTION_VALUES
+{
+    PLATFORM_INFO_OPTION_DEFAULT,
+    PLATFORM_INFO_OPTION_RETRIEVE_SQM
+} PLATFORM_INFO_OPTION;
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+    MOCKABLE_FUNCTION(, int, platform_init);
+    MOCKABLE_FUNCTION(, void, platform_deinit);
+    MOCKABLE_FUNCTION(, const IO_INTERFACE_DESCRIPTION*, platform_get_default_tlsio);
+    MOCKABLE_FUNCTION(, STRING_HANDLE, platform_get_platform_info, PLATFORM_INFO_OPTION, options);
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* PLATFORM_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/refcount.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/refcount.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/refcount.h	(revision 389)
@@ -0,0 +1,122 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+
+/*this header contains macros for ref_counting a variable.
+
+There are no upper bound checks related to uint32_t overflow because we expect that bigger issues are in
+the system when more than 4 billion references exist to the same variable. In the case when such an overflow
+occurs, the object's ref count will reach zero (while still having 0xFFFFFFFF references) and likely the
+controlling code will take the decision to free the object's resources. Then, any of the 0xFFFFFFFF references
+will interact with deallocated memory / resources resulting in an undefined behavior.
+*/
+
+#ifndef REFCOUNT_H
+#define REFCOUNT_H
+
+#include "azure_c_shared_utility/gballoc.h"
+#include "azure_c_shared_utility/macro_utils.h"
+
+#ifdef __cplusplus
+#include <cstdlib>
+#include <cstdint>
+extern "C"
+{
+#else
+#include <stdlib.h>
+#include <stdint.h>
+#endif
+
+// Include the platform-specific file that defines atomic functionality
+#include "refcount_os.h"
+
+#define REFCOUNT_TYPE(type) \
+struct MU_C2(MU_C2(REFCOUNT_, type), _TAG)
+
+#define REFCOUNT_SHORT_TYPE(type) \
+MU_C2(REFCOUNT_, type)
+
+#define REFCOUNT_TYPE_DECLARE_CREATE(type) MU_C2(REFCOUNT_SHORT_TYPE(type), _Create)
+#define REFCOUNT_TYPE_DECLARE_CREATE_WITH_EXTRA_SIZE(type) MU_C2(REFCOUNT_SHORT_TYPE(type), _Create_With_Extra_Size)
+#define REFCOUNT_TYPE_CREATE(type) MU_C2(REFCOUNT_SHORT_TYPE(type), _Create)()
+#define REFCOUNT_TYPE_CREATE_WITH_EXTRA_SIZE(type, size) MU_C2(REFCOUNT_SHORT_TYPE(type), _Create_With_Extra_Size)(size)
+#define REFCOUNT_TYPE_DECLARE_DESTROY(type) MU_C2(REFCOUNT_SHORT_TYPE(type), _Destroy)
+#define REFCOUNT_TYPE_DESTROY(type, var) MU_C2(REFCOUNT_SHORT_TYPE(type), _Destroy)(var)
+
+/*this introduces a new refcount'd type based on another type */
+/*and an initializer for that new type that also sets the ref count to 1. The type must not have a flexible array*/
+/*the newly allocated memory shall be free'd by free()*/
+/*and the ref counting is handled internally by the type in the _Create/ _Create_With_Extra_Size /_Clone /_Destroy functions */
+
+/* Codes_SRS_REFCOUNT_01_005: [ REFCOUNT_TYPE_CREATE_WITH_EXTRA_SIZE shall allocate memory for the type that is ref counted (type) plus extra memory enough to hold size bytes. ]*/
+/* Codes_SRS_REFCOUNT_01_006: [ On success it shall return a non-NULL handle to the allocated ref counted type type. ]*/
+/* Codes_SRS_REFCOUNT_01_007: [ If any error occurs, REFCOUNT_TYPE_CREATE_WITH_EXTRA_SIZE shall return NULL. ]*/
+#define DEFINE_CREATE_WITH_EXTRA_SIZE(type) \
+static type* REFCOUNT_TYPE_DECLARE_CREATE_WITH_EXTRA_SIZE(type)(size_t size) \
+{ \
+    REFCOUNT_TYPE(type)* ref_counted = (REFCOUNT_TYPE(type)*)malloc(sizeof(REFCOUNT_TYPE(type)) + size); \
+    type* result; \
+    if (ref_counted == NULL) \
+    { \
+        result = NULL; \
+    } \
+    else \
+    { \
+        result = &ref_counted->counted; \
+        INIT_REF(type, result); \
+    } \
+    return result; \
+} \
+
+/* Codes_SRS_REFCOUNT_01_002: [ REFCOUNT_TYPE_CREATE shall allocate memory for the type that is ref counted. ]*/
+/* Codes_SRS_REFCOUNT_01_003: [ On success it shall return a non-NULL handle to the allocated ref counted type type. ]*/
+/* Codes_SRS_REFCOUNT_01_004: [ If any error occurs, REFCOUNT_TYPE_CREATE shall return NULL. ]*/
+#define DEFINE_CREATE(type) \
+static type* REFCOUNT_TYPE_DECLARE_CREATE(type) (void) \
+{ \
+    return REFCOUNT_TYPE_DECLARE_CREATE_WITH_EXTRA_SIZE(type)(0); \
+} \
+
+/* Codes_SRS_REFCOUNT_01_008: [ REFCOUNT_TYPE_DESTROY shall free the memory allocated by REFCOUNT_TYPE_CREATE or REFCOUNT_TYPE_CREATE_WITH_EXTRA_SIZE. ]*/
+/* Codes_SRS_REFCOUNT_01_009: [ If counted_type is NULL, REFCOUNT_TYPE_DESTROY shall return. ]*/
+#define DEFINE_DESTROY(type) \
+static void REFCOUNT_TYPE_DECLARE_DESTROY(type)(type* counted_type) \
+{ \
+    void* ref_counted = (void*)((unsigned char*)counted_type - offsetof(REFCOUNT_TYPE(type), counted)); \
+    free(ref_counted); \
+}
+
+#define DEFINE_REFCOUNT_TYPE(type) \
+REFCOUNT_TYPE(type) \
+{ \
+    COUNT_TYPE count; \
+    type counted; \
+}; \
+DEFINE_CREATE_WITH_EXTRA_SIZE(type) \
+DEFINE_CREATE(type) \
+DEFINE_DESTROY(type) \
+
+#ifndef DEC_RETURN_ZERO
+#error refcount_os.h does not define DEC_RETURN_ZERO
+#endif // !DEC_RETURN_ZERO
+#ifndef INC_REF_VAR
+#error refcount_os.h does not define INC_REF_VAR
+#endif // !INC_REF
+#ifndef DEC_REF_VAR
+#error refcount_os.h does not define DEC_REF_VAR
+#endif // !DEC_REF
+#ifndef INIT_REF_VAR
+#error refcount_os.h does not define INIT_REF_VAR
+#endif // !INIT_REF
+
+#define INC_REF(type, var) INC_REF_VAR(((REFCOUNT_TYPE(type)*)((unsigned char*)var - offsetof(REFCOUNT_TYPE(type), counted)))->count)
+#define DEC_REF(type, var) DEC_REF_VAR(((REFCOUNT_TYPE(type)*)((unsigned char*)var - offsetof(REFCOUNT_TYPE(type), counted)))->count)
+#define INIT_REF(type, var) INIT_REF_VAR(((REFCOUNT_TYPE(type)*)((unsigned char*)var - offsetof(REFCOUNT_TYPE(type), counted)))->count)
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /*REFCOUNT_H*/
+
+
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/sastoken.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/sastoken.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/sastoken.h	(revision 389)
@@ -0,0 +1,23 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef SASTOKEN_H
+#define SASTOKEN_H
+
+#include "azure_c_shared_utility/strings.h"
+#include <stdbool.h>
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+    MOCKABLE_FUNCTION(, bool, SASToken_Validate, STRING_HANDLE, sasToken);
+    MOCKABLE_FUNCTION(, STRING_HANDLE, SASToken_Create, STRING_HANDLE, key, STRING_HANDLE, scope, STRING_HANDLE, keyName, size_t, expiry);
+    MOCKABLE_FUNCTION(, STRING_HANDLE, SASToken_CreateString, const char*, key, const char*, scope, const char*, keyName, size_t, expiry);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* SASTOKEN_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/sha-private.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/sha-private.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/sha-private.h	(revision 389)
@@ -0,0 +1,33 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+/*************************** sha-private.h ***************************/
+/********************** See RFC 4634 for details *********************/
+#ifndef _SHA_PRIVATE__H
+#define _SHA_PRIVATE__H
+/*
+* These definitions are defined in FIPS-180-2, section 4.1.
+* Ch() and Maj() are defined identically in sections 4.1.1,
+* 4.1.2 and 4.1.3.
+*
+* The definitions used in FIPS-180-2 are as follows:
+*/
+
+#ifndef USE_MODIFIED_MACROS
+#define SHA_Ch(x,y,z)        (((x) & (y)) ^ ((~(x)) & (z)))
+#define SHA_Maj(x,y,z)       (((x) & (y)) ^ ((x) & (z)) ^ ((y) & (z)))
+
+#else /* USE_MODIFIED_MACROS */
+/*
+* The following definitions are equivalent and potentially faster.
+*/
+
+#define SHA_Ch(x, y, z)      (((x) & ((y) ^ (z))) ^ (z))
+#define SHA_Maj(x, y, z)     (((x) & ((y) | (z))) | ((y) & (z)))
+
+#endif /* USE_MODIFIED_MACROS */
+
+#define SHA_Parity(x, y, z)  ((x) ^ (y) ^ (z))
+
+#endif /* _SHA_PRIVATE__H */
+
